Name:           ann
Version:        1.1.2
Release:    1%{?dist}
Summary:        Library for searching Approximate Nearest Neighbors

License:        LGPLv2+
URL:            http://www.cs.umd.edu/~mount/ANN
Source0:        http://www.cs.umd.edu/~mount/ANN/Files/%{version}/%{name}_%{version}.tar.gz
Patch0:         ann-make.patch
Patch1:         ann-gcc43.patch
BuildRequires:  gcc-c++
BuildRequires: make


%description
ANN is a library written in the C++ programming language to support both
exact and approximate nearest neighbor searching in spaces of various
dimensions.  It was implemented by David M. Mount of the University of
Maryland, and Sunil Arya of the Hong Kong University of Science and
Technology.  ANN (pronounced like the name ``Ann'') stands for
Approximate Nearest Neighbors.  ANN is also a testbed containing
programs and procedures for generating data sets, collecting and
analyzing statistics on the performance of nearest neighbor algorithms
and data structures, and visualizing the geometric structure of these
data structures.

%package libs
Summary:        Runtime files for the ANN library

%description libs
Runtime files needed to use ANN library.

%package devel
Summary:        Development files for the ANN library
Requires:       %{name}-libs = %{version}-%{release}

%description devel
Development files needed to use ANN library.


%prep
%setup -q -n %{name}_%{version}
%patch0 -p1 -b .make
%patch1 -p1 -b .gcc43


%build
%make_build linux CFLAGS="-fPIC -DPIC $RPM_OPT_FLAGS"


%install
mkdir -p %{buildroot}%{_includedir}/ANN
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_libdir}/pkgconfig
mkdir -p %{buildroot}%{_bindir}

install -p -m 0644 include/ANN/*.h %{buildroot}%{_includedir}/ANN
install -p -m 0755 lib/libANN.so.* %{buildroot}%{_libdir}
install -p -m 0755 bin/ann2fig %{buildroot}%{_bindir}

pushd %{buildroot}%{_libdir}
ln -s libANN.so.1.0 libANN.so.1
ln -s libANN.so.1.0 libANN.so
popd

cat << EOF > %{buildroot}%{_libdir}/pkgconfig/%{name}.pc
prefix=%{_prefix}
exec_prefix=%{_exec_prefix}
libdir=%{_libdir}
includedir=%{_includedir}

Name: %{name}
Description: Library for searching Approximate Nearest Neighbors
Version: %{version}
Requires:
Libs: -L\${libdir} -lANN
Cflags: -I\${includedir}
EOF


%files
%{_bindir}/*

%files libs
%doc Copyright.txt License.txt ReadMe.txt
%{_libdir}/*.so.*

%files devel
%doc doc/ANNmanual.pdf
%{_includedir}/ANN
%{_libdir}/*.so
%{_libdir}/pkgconfig/%{name}.pc


%changelog
* Wed Jul 24 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.1.2-1
- initial build
